%global meadalpha %{nil}
%global meadrel %{nil}
%global version_major 21
%global version_minor 3
%global version_micro 5
%global version_release 0
%global serial 1
%global version_full %{version_major}.%{version_minor}.%{version_micro}.%{version_release}_1
%global mandrel_version %(echo -n %{version_full} | tr '_' '-')b%{serial}

# Commit ids corresponding to the sources listed in the source-repos
# file. These globals are automatically updated by mead (by reading
# the source-repos file) and should be named "commitid" for the first
# source (Source0) and "commitidX" for the following sources, where X
# corresponds to the number of the source (as in SourceX),
%global commitid mandrel-21.3.5.0-Final-1
%global commitid1 5.309.2
%global commitid2 mandrel-21.3.5.0-Final-1

# Workaround for stripping of debug symbols from static libraries
# see: https://issues.redhat.com/projects/MANDREL/issues/MANDREL-8
%global debug_package %{nil}
%global __brp_strip_static_archive %{nil}

# Mandrel is sensitive to internal changes of the JDK so we need to make sure
# it is compatible with the installed JDK, thus we require a specific
# jdk version to be installed.
%global jdkversion %(rpm -q --qf '%%{VERSION}-%%{RELEASE}' java-17-openjdk || : )
%global jdkepoch %(rpm -q --qf '%%{EPOCH}:' java-17-openjdk || : )
%global jdkdir %{_jvmdir}/java-17-openjdk-%{jdkversion}.%{_arch}
%global mandrel_temp_dir mandrelJDK

%ifarch x86_64
%global install_arch amd64
%endif

Name:    quarkus-mandrel-17-jdk
Version: %{version_full}
Release: %{serial}%{?dist}
Summary: Mandrel (JDK 17-based)
License: GPLv2 with exceptions
URL:     https://github.com/graalvm/mandrel/

Source0: mandrel-%{commitid}.tar.gz
Source1: mx-%{commitid1}.tar.gz
Source2: mandrel-packaging-%{commitid2}.tar.gz

ExclusiveArch: x86_64
BuildRequires: python3
BuildRequires: ninja-build
BuildRequires: java-17-openjdk-static-libs
BuildRequires: quarkus-mandrel-java-17-jdk-binding = %{version}
BuildRequires: zlib-devel
Requires: java-17-openjdk-static-libs = %{jdkepoch}%{jdkversion}
Requires: quarkus-mandrel-java-17-jdk-binding = %{version}
Requires: zlib-devel
# Post requires alternatives to install tool alternatives
Requires(post):   %{_sbindir}/alternatives
# Postun requires alternatives to uninstall tool alternatives
Requires(postun): %{_sbindir}/alternatives

%description
%{summary}

%prep

if [ -z "%jdkversion" ]
then
    echo "rpm failed to obtain java-11-openjdk version, check BuildRequires"
    exit 11
fi

%setup -q -n mandrel-%{commitid}

%{__mkdir_p} %{_builddir}/mx
%{__tar} xf %{S:1} -C %{_builddir}/mx --strip-components=1

%{__mkdir_p} %{_builddir}/mandrel-packaging
%{__tar} xf %{S:2} -C %{_builddir}/mandrel-packaging --strip-components=1

%build
export PATH=$PATH:%{_builddir}/mx
export MX_PYTHON=%{__python3}

cp -a %{jdkdir} patched-java
export JAVA_HOME=./patched-java

# unzip mandrel-packaging-wrapper
%{__unzip} %{_javadir}/quarkus-mandrel-java-17-jdk/mandrel-packaging-wrapper-linux-amd64.jar
# cp the extracted files to java home
%{__mkdir_p} $JAVA_HOME/lib/svm
%{__cp} -a ./sdk/mxbuild/native-image.properties $JAVA_HOME/lib/svm/macros
%{__mkdir_p} $JAVA_HOME/lib/svm/bin
%{__install} -Dpm0755 sdk/mxbuild/linux-amd64/native-image.image-bash/native-image $JAVA_HOME/lib/svm/bin/

$JAVA_HOME/bin/java -ea %{_builddir}/mandrel-packaging/build.java \
    --mx-home %{_builddir}/mx \
    --mandrel-repo ./ \
    --mandrel-home %{_builddir}/%{mandrel_temp_dir} \
    --mandrel-version %{mandrel_version} \
    --skip-java \
    --verbose \
    --skip-clean

%install
# Headers and native libs
%{__mkdir} -p %{buildroot}/%{jdkdir}/lib/svm
cp -a %{_builddir}/%{mandrel_temp_dir}/lib/svm/clibraries %{buildroot}/%{jdkdir}/lib/svm/clibraries
ls -la %{_builddir}/%{mandrel_temp_dir}/lib/svm/clibraries %{buildroot}/%{jdkdir}/lib/svm/clibraries

# Macros
cp -a %{_builddir}/%{mandrel_temp_dir}/lib/svm/macros %{buildroot}/%{jdkdir}/lib/svm/macros
ls -la %{_builddir}/%{mandrel_temp_dir}/lib/svm/macros %{buildroot}/%{jdkdir}/lib/svm/macros

# Executable
%{__install} -Dpm0755 %{_builddir}/%{mandrel_temp_dir}/bin/native-image %{buildroot}/%{jdkdir}/lib/svm/bin/native-image
%{__mkdir} %{buildroot}/%{jdkdir}/bin
%{__ln_s} ../lib/svm/bin/native-image %{buildroot}/%{jdkdir}/bin/native-image

# Agents
%{__install} -Dpm0644 %{_builddir}/%{mandrel_temp_dir}/lib/libnative-image-agent.so %{buildroot}/%{jdkdir}/lib/
%{__install} -Dpm0644 %{_builddir}/%{mandrel_temp_dir}/lib/libnative-image-agent.h %{buildroot}/%{jdkdir}/lib/
%{__install} -Dpm0644 %{_builddir}/%{mandrel_temp_dir}/lib/libnative-image-agent_dynamic.h %{buildroot}/%{jdkdir}/lib/
%{__install} -Dpm0644 %{_builddir}/%{mandrel_temp_dir}/lib/libnative-image-diagnostics-agent.so %{buildroot}/%{jdkdir}/lib/
%{__install} -Dpm0644 %{_builddir}/%{mandrel_temp_dir}/lib/libnative-image-diagnostics-agent.h %{buildroot}/%{jdkdir}/lib/
%{__install} -Dpm0644 %{_builddir}/%{mandrel_temp_dir}/lib/libnative-image-diagnostics-agent_dynamic.h %{buildroot}/%{jdkdir}/lib/

%check
# Check debug symbols in static libraries (smoke test)
export STATIC_LIBS_HOME=%{buildroot}/%{jdkdir}/lib/svm/clibraries/linux-%{install_arch}/
readelf --debug-dump $STATIC_LIBS_HOME/liblibchelper.a | grep cpuid.c
readelf --debug-dump $STATIC_LIBS_HOME/libjvm.a | grep JvmFuncs.c

%{__cp} -r %{jdkdir} %{_tmppath}/mandrel-test
%{__cp} -nr %{buildroot}/%{jdkdir}/* %{_tmppath}/mandrel-test

pushd %{_tmppath}/mandrel-test
./bin/native-image --version
echo "public class Version{ public static void main(String[] args) {System.out.println(System.getProperty(\"java.runtime.version\"));}}" > Version.java
JDK_VERSION=$(java Version.java)
./bin/native-image --version  | grep -e "^native-image %{mandrel_version} Mandrel Distribution (Java Version ${JDK_VERSION})$"

echo "
public class HelloStrict
{
    public static void main(String[] args)
    {
        System.out.printf(
            \"Hello %1$,.12f %2$,.12f %3$,.12f %n\"
            , StrictMath.cos(0.0)
            , StrictMath.IEEEremainder(3.0, 5.0)
            , StrictMath.IEEEremainder(-16.3, 4.1)
        );
    }
}
" > HelloStrict.java
./bin/javac HelloStrict.java
./bin/java HelloStrict > java.txt
./bin/native-image --report-unsupported-elements-at-runtime HelloStrict
./hellostrict > native.txt
diff java.txt native.txt

popd
%{__rm} -rf %{_tmppath}/mandrel-test

%post
alternatives --add-slave javac %{jdkdir}/bin/javac %{_bindir}/native-image native-image %{jdkdir}/bin/native-image

%postun
alternatives --remove-slave javac %{jdkdir}/bin/javac native-image

%files
%{jdkdir}/lib/svm/clibraries/linux-%{install_arch}/include/amd64cpufeatures.h
%{jdkdir}/lib/svm/clibraries/linux-%{install_arch}/include/aarch64cpufeatures.h
%{jdkdir}/lib/svm/clibraries/linux-%{install_arch}/include/svm_libffi.h
%{jdkdir}/lib/svm/clibraries/linux-%{install_arch}/include/trufflenfi.h
%{jdkdir}/lib/svm/clibraries/linux-%{install_arch}/liblibchelper.a
%{jdkdir}/lib/svm/clibraries/linux-%{install_arch}/libjvm.a
%{jdkdir}/lib/svm/bin/native-image
%{jdkdir}/bin/native-image
%{jdkdir}/lib/svm/macros/native-image-agent-library/native-image.properties
%{jdkdir}/lib/svm/macros/native-image-launcher/native-image.properties
%{jdkdir}/lib/svm/macros/native-image-diagnostics-agent-library/native-image.properties
%{jdkdir}/lib/libnative-image-agent.so
%{jdkdir}/lib/libnative-image-agent.h
%{jdkdir}/lib/libnative-image-agent_dynamic.h
%{jdkdir}/lib/libnative-image-diagnostics-agent.so
%{jdkdir}/lib/libnative-image-diagnostics-agent.h
%{jdkdir}/lib/libnative-image-diagnostics-agent_dynamic.h

%changelog
* Mon Jan 16 2023 cpaas-ops <cpaas-ops@redhat.com> - 21.3.5.0_1-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Wed Jan 11 2023 cpaas-ops <cpaas-ops@redhat.com> - 21.3.4.0_1-10
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Jan 10 2023 cpaas-ops <cpaas-ops@redhat.com> - 21.3.4.0_1-9
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Jan 10 2023 cpaas-ops <cpaas-ops@redhat.com> - 21.3.4.0_1-8
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Dec 01 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.4.0_1-7
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Nov 17 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.4.0_1-6
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Wed Nov 16 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.4.0_1-5
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Nov 11 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.4.0_1-4
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Nov 10 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.4.0_1-3
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Oct 17 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.4.0_1-2
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Oct 17 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.4.0_1-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Sep 26 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.3.0_1-9
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Sep 15 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.3.0_1-8
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Wed Sep 07 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.3.0_1-7
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Aug 22 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.3.0_1-6
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Aug 19 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.3.0_1-5
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Aug 11 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.3.0_1-4
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Aug 11 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.3.0_1-3
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Jul 25 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.3.0_1-2
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Jul 25 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.3.0_1-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Jul 14 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.2.0_1-9
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Jul 07 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.2.0_1-8
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Wed Jul 06 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.2.0_1-7
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Jul 04 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.2.0_1-6
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri May 13 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.2.0_1-5
Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Apr 26 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.2.0_1-4
Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Apr 19 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.2.0_1-3
Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Apr 15 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.2.0_1-2
Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Apr 15 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.2.0_1-1
Built by CPaaS

* Thu Apr 14 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.2.0_1-1
Built by CPaaS

* Wed Mar 02 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.1.1_1-2
Built by CPaaS

* Wed Mar 02 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.1.1_1-1
Built by CPaaS

* Tue Mar 01 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.1.0_1-4
Built by CPaaS

* Mon Feb 28 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.1.0_1-3
Built by CPaaS

* Fri Feb 25 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.1.0_1-2
Built by CPaaS

* Fri Feb 25 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.1.0_1-1
Built by CPaaS

* Tue Feb 22 2022 Severin Gehwolf <sgehwolf@redhat.com> - 21.3.1.0_1-5
- Add native image FIPS support patches

* Mon Feb 21 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.1.0_0-5
Built by CPaaS

* Fri Feb 11 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.1.0_0-4
Built by CPaaS

* Fri Feb 11 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.1.0_0-3
Built by CPaaS

* Fri Feb 04 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.1.0_0-2
Built by CPaaS

* Fri Feb 04 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.1.0_0-1
Built by CPaaS

* Thu Feb 03 2022 cpaas-ops <cpaas-ops@redhat.com> - 21.3.1.0_0-1
Built by CPaaS

* Thu Feb 03 2022 Severin Gehwolf <sgehwolf@redhat.com> - 21.3.1.0_0-1
Initial package
